package pomodoro

import (
	"git.smsvc.net/pomodoro/GoTomato/internal/shared"
	"time"
)

type Timer struct {
	abort  chan bool
	wait   chan bool
	resume chan bool
}

func (t Timer) Init() Timer {
	return Timer{
		abort:  make(chan bool, 1),
		wait:   make(chan bool, 1),
		resume: make(chan bool, 1),
	}
}

func (t *Timer) Start(duration int) bool {
	for timeLeft := duration; timeLeft > 0; {
		select {
		case <-t.abort:
			return false
		case <-t.wait:
			<-t.resume
		default:
			shared.Message.TimeLeft = timeLeft
			time.Sleep(time.Second)
			timeLeft--
		}
	}

	// Final shared.Message when time reaches zero
	shared.Message.TimeLeft = 0

	return true
}

func (t *Timer) Stop() {
	t.resume <- true
	t.abort <- true
}

func (t *Timer) Pause() {
	t.wait <- true
}

func (t *Timer) Resume() {
	t.resume <- true
}
